package com.njcn.csharmonic.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.csharmonic.api.CsHarmonicFeignClient;
import com.njcn.csharmonic.pojo.po.CsHarmonic;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author xy
 */
@Slf4j
@Component
public class CsHarmonicFeignClientFallbackFactory implements FallbackFactory<CsHarmonicFeignClient> {
    @Override
    public CsHarmonicFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if (cause.getCause() instanceof BusinessException) {
            BusinessException businessException = (BusinessException) cause.getCause();
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new CsHarmonicFeignClient() {
            @Override
            public HttpResult<Boolean> addList(List<CsHarmonic> list) {
                log.error("{}异常，降级处理，异常为：{}","批量写入数据异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<List<CsHarmonic>> queryListByTime(String time) {
                log.error("{}异常，降级处理，异常为：{}","按日期查询数据异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public HttpResult<Boolean> deleteListByTime(String time) {
                log.error("{}异常，降级处理，异常为：{}","按日期删除数据异常",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
